<!--
  -   Copyright 2014-2023 IHE International
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<ui:composition xmlns:rich="http://richfaces.org/rich" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:g="http://www.ihe.net/gazelle"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm" rendered="#{AuditMessageViewer.selectedAuditMessage != null}">
            <h2>#{messages['net.ihe.gazelle.audit.message.AuditMessage']}
                #{AuditMessageViewer.selectedAuditMessage.name}</h2>

            <p>
                <h:outputLink value="#{AuditMessageViewer.linkToListAuditMessage()}" styleClass="gzl-btn">
                    <h:outputText value="#{messages['net.ihe.gazelle.audit.message.BackToList']}"/>
                </h:outputLink>
                <h:outputLink value="#{AuditMessageViewer.linkToEditAuditMessage(AuditMessageViewer.selectedAuditMessage.id)}"
                              styleClass="gzl-btn-blue"
                              rendered="#{s:hasRole('admin_role') or s:hasRole('tests_editor_role')}">
                    <span class="fa fa-pencil"></span>
                    <h:outputText value="#{messages['net.ihe.gazelle.audit.message.Edit']}"/>
                </h:outputLink>
            </p>
            <ui:decorate template="/layout/panels/_panel.xhtml">
                <dl class="dl-horizontal">
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.Name']}</ui:define>
                        <h:outputText value="#{AuditMessageViewer.selectedAuditMessage.name}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.OID']}</ui:define>
                        <h:outputText value="#{AuditMessageViewer.selectedAuditMessage.oid}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.DocumentReference']}</ui:define>
                        <h:outputText value="#{AuditMessageViewer.selectedAuditMessage.document}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.Section']}</ui:define>
                        <h:outputText value="#{AuditMessageViewer.selectedAuditMessage.section}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.LastChange']}</ui:define>
                        <g:date value="#{AuditMessageViewer.selectedAuditMessage.lastChanged}"/>
                        <h:outputText
                                value=" #{messages['net.ihe.gazelle.audit.message.By']} #{AuditMessageViewer.getUserName(AuditMessageViewer.selectedAuditMessage.lastModifierId)}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.Schema']}</ui:define>
                        <h:outputText value="#{AuditMessageViewer.selectedAuditMessage.schema}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.DicomCompatible']}</ui:define>
                        <h:outputText value="#{AuditMessageViewer.selectedAuditMessage.isDicomCompatible}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.DeprecateRFC3881Validation']}
                        </ui:define>
                        <h:outputText value="#{AuditMessageViewer.selectedAuditMessage.forceDicomCompatibility}"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.DeprecatedValidator']}</ui:define>
                        <h:outputText value="#{AuditMessageViewer.selectedAuditMessage.isDeprecated}"/>
                    </ui:decorate>
                </dl>

                <f:subview id="subview_1">
                    <ui:include src="view/eventView.xhtml"/>
                </f:subview>


                <dl id="carddiv" class="dl-horizontal">

                    <ui:repeat value="#{AuditMessageViewer.selectedAuditMessage.activeParticipants}" var="actpart">
                        <ui:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{actpart.name}</ui:define>
                            <h:outputText value="#{actpart.min} .. #{actpart.max}"/>
                        </ui:decorate>
                    </ui:repeat>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml"
                                 rendered="#{AuditMessageViewer.selectedAuditMessage.auditSource != null}">
                        <ui:define name="label">#{messages['net.ihe.gazelle.audit.message.AuditSourceIdentification']}</ui:define>
                        <h:outputText
                                value="#{AuditMessageViewer.selectedAuditMessage.auditSource.min} .. #{AuditMessageViewer.selectedAuditMessage.auditSource.max}"/>
                    </ui:decorate>
                    <ui:repeat value="#{AuditMessageViewer.selectedAuditMessage.participantObjectIdentifications}"
                               var="partid">
                        <ui:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{partid.name}</ui:define>
                            <h:outputText value="#{partid.min} .. #{partid.max}"/>
                        </ui:decorate>
                    </ui:repeat>
                </dl>

                <ui:repeat value="#{AuditMessageViewer.selectedAuditMessage.activeParticipants}" var="actpart">
                    <f:subview id="subview_2">
                        <ui:include src="view/actPartView.xhtml">
                            <ui:param name="activeParticipant" value="#{actpart}"/>
                        </ui:include>
                    </f:subview>
                </ui:repeat>

                <s:div rendered="#{AuditMessageViewer.selectedAuditMessage.auditSource != null}">
                    <f:subview id="subview_3">
                        <ui:include src="view/auditSourceView.xhtml">
                            <ui:param name="auditSource"
                                      value="#{AuditMessageViewer.selectedAuditMessage.auditSource}"/>
                        </ui:include>
                    </f:subview>
                </s:div>

                <ui:repeat value="#{AuditMessageViewer.selectedAuditMessage.participantObjectIdentifications}"
                           var="partid">
                    <f:subview id="subview_4">
                        <ui:include src="view/partIdentificationView.xhtml">
                            <ui:param name="partIdentification" value="#{partid}"/>
                        </ui:include>
                    </f:subview>
                </ui:repeat>

                <s:div id="extradiv"
                       rendered="#{AuditMessageViewer.selectedAuditMessage.extraConstraintSpecifications.size() &gt; 0}">
                    <h3>
                        <h:outputText value="#{messages['net.ihe.gazelle.audit.message.ExtraConstraints']}"/>
                    </h3>
                    <rich:dataTable value="#{AuditMessageViewer.selectedAuditMessage.extraConstraintSpecifications}"
                                    var="extra"
                                    rendered="#{AuditMessageViewer.selectedAuditMessage.extraConstraintSpecifications.size() &gt; 0}">
                        <rich:column>
                            <f:facet name="header">#{messages['net.ihe.gazelle.audit.message.Id']}</f:facet>
                            <h:outputText value="#{extra.id}"/>
                        </rich:column>
                        <rich:column>
                            <f:facet name="header">#{messages['net.ihe.gazelle.audit.message.Kind']}</f:facet>
                            <h:outputText value="#{extra.kind}"/>
                        </rich:column>
                        <rich:column>
                            <f:facet name="header">#{messages['net.ihe.gazelle.audit.message.Xpath']}</f:facet>
                            <h:outputText value="#{extra.xpath}"/>
                        </rich:column>
                        <rich:column>
                            <f:facet name="header">#{messages['net.ihe.gazelle.audit.message.Description']}</f:facet>
                            <h:outputText value="#{extra.description}"/>
                        </rich:column>
                    </rich:dataTable>
                </s:div>
            </ui:decorate>
        </h:form>

        <s:div styleClass="gzl-alert gzl-alert-red" rendered="#{AuditMessageViewer.selectedAuditMessage == null}">
            <h:outputText
                    value="#{messages['net.ihe.gazelle.audit.message.TheIdSpecifiedIsNotWellPleaseSpecifyAGoodIDOnThe']}"/>
        </s:div>

        <p>
            <h:outputLink value="#{AuditMessageViewer.linkToListAuditMessage()}" styleClass="gzl-btn">
                <h:outputText value="#{messages['net.ihe.gazelle.audit.message.BackToList']}"/>
            </h:outputLink>
        </p>
    </ui:define>
</ui:composition>
